!  @(#)omp_lib.h 1.4 (Sun Microsystems, Inc.) 03/11/03
!    Copyright \251 2000 Sun Microsystems, Inc.
!    All rights reserved.
! OpenMP 2.0 interface include file

        integer, parameter :: openmp_version = 200011

! The next two parameters are the kind of an integer
! large enough to hold an
! address under v8 or v9. The implementation is opaque.

        integer, parameter :: omp_lock_kind = 8
        integer, parameter :: omp_nest_lock_kind = 8

        interface

        subroutine omp_destroy_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        subroutine omp_destroy_nest_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        function omp_get_dynamic()
        logical(kind=4) :: omp_get_dynamic
        end function

        function omp_get_max_threads()
        integer(kind=4) :: omp_get_max_threads
        end function

        function omp_get_nested()
        logical(kind=4) :: omp_get_nested
        end function

        function omp_get_num_procs()
        integer(kind=4) :: omp_get_num_procs
        end function

        function omp_get_num_threads()
        integer(kind=4) :: omp_get_num_threads
        end function

        function omp_get_thread_num()
        integer(kind=4) :: omp_get_thread_num
        end function

        function omp_get_wtick()
        real(kind=8) :: omp_get_wtick
        end function

        function omp_get_wtime()
        real(kind=8) :: omp_get_wtime
        end function

        subroutine omp_init_lock(var)
        integer(kind=8), intent(out) :: var
        end subroutine

        subroutine omp_init_nest_lock(var)
        integer(kind=8), intent(out) :: var
        end subroutine

        function omp_in_parallel()
        logical(kind=4) :: omp_in_parallel
        end function

        subroutine omp_set_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        subroutine omp_set_nest_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        function omp_test_lock(var)
        logical(kind=4) :: omp_test_lock
        integer(kind=8), intent(inout) :: var
        end function

        function omp_test_nest_lock(var)
        integer(kind=4) :: omp_test_nest_lock
        integer(kind=8), intent(inout) :: var
        end function

        subroutine omp_unset_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        subroutine omp_unset_nest_lock(var)
        integer(kind=8), intent(inout) :: var
        end subroutine

        subroutine omp_set_dynamic(enable)
        logical(kind=4), intent(in) :: enable
        end subroutine

        subroutine omp_set_nested(enable)
        logical(kind=4), intent(in) :: enable
        end subroutine

        subroutine omp_set_num_threads(enable)
        integer(kind=4), intent(in) :: enable
        end subroutine

        end interface

